const std = @import("std");

pub fn djb2(comptime int: std.builtin.Type.Int, bytes: []const u8) std.meta.Int(int.signedness, int.bits) {
	var hash = @as(std.meta.Int(int.signedness, int.bits), 5381);

	for (bytes) |byte| {
		hash = ((hash << 5) +% hash) +% byte;
	}

	return hash;
}

pub fn jenkins(comptime int: std.builtin.Type.Int, bytes: []const u8) std.meta.Int(int.signedness, int.bits) {
    var hash = @as(std.meta.Int(int.signedness, int.bits), 0);

    for (bytes) |byte| {
        hash +%= byte;
        hash +%= (hash << 10);
        hash ^= (hash >> 6);
    }

    hash +%= (hash << 3);
    hash ^= (hash >> 11);
    hash +%= (hash << 15);

    return hash;
}
